#include <bits/stdc++.h>
#define int long long
using namespace std;
int n,k,t;
vector<int>a;
signed main()
{
cin>>t>>n>>k;
a.resize(n);
for(int i = 0;i<n;i++)
cin>>a[i];
sort(a.begin(),a.end());
int curr=0;
for(int i = 0;i<n;i++){
if(a[i]>=curr)curr++;
else
curr--;
}
if(curr==k){
cout<<"DA"<<endl;
if(t==1)
for(int i = 0;i<n;i++)
cout<<a[i]<<" ";
}
else
cout<<"NE"<<endl;


    return 0;
}